#include "GameObject.h"
#include "Punkt.h"


GameObject::GameObject( VariableTyp typ, int x, int y, int width, int height )
    : Variable( typ )
{
    this->x = (float)x;
    this->y = (float)y;
    w = (float)width;
    h = (float)height;
    zTextur = 0;
    texturScale = 0;
}

void GameObject::setX( float x )
{
    this->x = x;
}

void GameObject::setY( float y )
{
    this->y = y;
}

void GameObject::setWidth( float width )
{
    w = width;
}

void GameObject::setHeight( float height )
{
    h = height;
}

bool GameObject::intersectsWith( GameObject *zObj )
{
    return x < zObj->x + zObj->w && x + w > zObj->x && y < zObj->y + zObj->h && y + h > zObj->y;
}

void GameObject::render( Bild &rObj )
{
    if( zTextur )
    {
        if( rObj.setDrawOptions( (int)x, (int)y, (int)w, (int)h ) )
        {
            if( texturScale )
                rObj.alphaBildSkall( (int)x, (int)y, (int)w, (int)h, *zTextur );
            else
            {
                for( int xx = (int)x; xx < x + w; x += zTextur->getBreite() )
                {
                    for( int yy = (int)y; yy < y + h; y += zTextur->getHeight() )
                        rObj.alphaBild( xx, yy, zTextur->getBreite(), zTextur->getHeight(), *zTextur );
                }
            }
            rObj.releaseDrawOptions();
        }
    }
}

float GameObject::getX() const
{
    return x;
}

float GameObject::getY() const
{
    return y;
}

float GameObject::getWidth() const
{
    return w;
}

float GameObject::getHeight() const
{
    return h;
}

float GameObject::abstandZu( GameObject *zObj )
{
    return ( Vec2<float>( x + w / 2, y + h / 2 ) - Vec2<float>( zObj->x + zObj->w / 2, zObj->y + zObj->h / 2 ) ).getLength();
}
